"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var Router = /** @class */ (function () {
    function Router(routes) {
        var _this = this;
        this._setParams = function (params) {
            _this.params = params;
        };
        this._setMatchedRoute = function (route) {
            _this.matchedRoute = route;
        };
        this._setCurrentTitle = function (title) {
            _this.currentTitle = title;
        };
        this._removeHash = function () {
            return history.replaceState(null, document.title, ' ');
        };
        this._syncWithHash = function () {
            var hash = location.hash;
            var _a = utils_1.getRouteAndParamsFromHash(hash, Object.keys(_this._routes)), route = _a.route, params = _a.params, reconstructedHash = _a.reconstructedHash;
            _this._setParams(params);
            _this._setMatchedRoute(_this._routes[route]);
            _this._setCurrentTitle(_this._titles[route]);
            if (reconstructedHash === '#') {
                _this._removeHash();
            }
            else {
                history.replaceState(undefined, document.title, reconstructedHash);
            }
            document.title = _this.currentTitle;
        };
        this.setRoutes = function (routes) {
            Object.entries(routes).forEach(function (_a) {
                var route = _a[0], title = _a[1];
                _this._routes[route] = route;
                _this._titles[route] = title;
                if (route === '/') {
                    _this._routes[''] = route;
                    _this._titles[''] = title;
                }
            });
            _this._syncWithHash();
        };
        this.navigateTo = function (route) {
            location.hash = "#" + route;
        };
        // TODO: Consider removing this
        this.refresh = function () { return _this._syncWithHash(); };
        this._callChangeListeners = function () {
            _this._changeListeners.forEach(function (changeListener) {
                changeListener({ params: _this.params, matchedRoute: _this.matchedRoute });
            });
        };
        this.addChangeListener = function (changeListenerToBeAdded) {
            _this._changeListeners = utils_1.withChangeListener(_this._changeListeners, changeListenerToBeAdded);
        };
        this.removeChangeListener = function (changeListenerToBeRemoved) {
            _this._changeListeners = utils_1.withoutChangeListener(_this._changeListeners, changeListenerToBeRemoved);
        };
        this.params = {};
        this.matchedRoute = '';
        this.currentTitle = '';
        this._routes = {};
        this._titles = {};
        this._changeListeners = [];
        this.setRoutes(routes);
        window.addEventListener('hashchange', function () {
            _this._syncWithHash();
            _this._callChangeListeners();
        });
    }
    return Router;
}());
exports.default = Router;
